function pen = cossopen(M, x, y, ord, K1, K0, lams, theta0, niter, flag_theta0),

% M=10^logM;
d = size(x,2);
D=d;
if ord==2,
  D = d * (d+1)/2;
end

if nargin<9 | isempty(niter),
  niter = 2;
end
if nargin<10 | isempty(flag_theta0),
  flag_theta0 = 0;
end

n=length(y);

% out = solve_bc(y, Kth0, K3darray, lambda0, ord, ones(D,1), w);
% [yt2, out] = tcubic_spl_k(x, y, lams, ord, sign(theta0));
[yt2, out] = tcubic_spl_cosso(x, y, K1, K0, lams, ord, theta0);

% [G0, yfit]=tcubic_anova(x, out, sign(theta0(1:d)), lams.lamk1, sign(theta0(d+1:end)), lams.lamk2); 
[G0, yfit]=tcubic_anova_cosso(x, out, K1, K0, sign(theta0(1:d)), lams.lamk1, sign(theta0(d+1:end)), lams.lamk2); 
G0=[G0, yfit];
clear yfit,
b0=out.d(1);
c0=out.c;

[lams, oo] = gettheta(x, y, G0, c0, b0, K1, K0, lams, M, theta0, niter, flag_theta0);
pen=oo.bic;
  
