function [H, H01] = cubic_dm(X, Y);

nc=length(X);
if nargin==1,
  Y=X;
end
nr=length(Y);

H=zeros(nr,nc);
for i=1:nc,
  H(:,i)=K2(X(i)).*K2(Y)-K4(abs(X(i)-Y));
  
end

if nargout>1,
  H01=H*0;
  for i=1:nc,
    H01(:,i)=K1(X(i)).*K1(Y);
  end

end

return


function k1 = K1(x),

k1=x-0.5;
return


function k2= K2(x),

k2 = 0.5.*(K1(x).^2-1/12);
return

function k4=K4(x),

k4 = 1/24.*(K1(x).^4-K1(x).^2./2+7/240);
return
