function [yt, out] = cubic_spl_k(X, y, lamk);

n = length(y);
np=size(X,2);
lam=1;
if length(lamk)~=np,
  if length(lamk)>1,
    error('wrong dimension for  lam')
    return
  else
    lamk=lamk(ones(np,1));
  end
end

Q=zeros(n,n);
S=[ones(n,1) X-0.5];
for j=1:size(X,2),
%   if cubic_df(lamk(j),n)==2,
%     lamk(j)=0;
%   end
  Q = Q+cubic_dm(X(:,j))./lamk(j);
end

if any(isfinite(lamk)),
[yt, out] = splfun(y,1,S,Q);

else
[yt, out] = splfun(y,1,S);
end
