function [gcv, out] = gcv_k_opt(lnvr, y, S, Q, gcv_pen, df_lim)

if nargin<5 | isempty(gcv_pen),
  gcv_pen=1;
end

nvr=10^lnvr;
n=length(y);
if nargin<6 | isempty(df_lim),
  df_lim=[0 .5*n];
end
[yt, out] = splfun(y,1/nvr/n^4,S,Q, gcv_pen);
% [yt, out] = tcubic_spl_k(X, y, 1/nvr/n^4, ord, chk);
if out.df<df_lim(1) | out.df > df_lim(2),
  gcv=inf;
else
  gcv=out.gcv;
end