function hfig = gsa_sdp_plot(gsa_,fname,pnames,indx, yi_anal)

if nargin<4 | isempty(indx),
  np = size(gsa_.xx,2);
  indx = [1:np];
else
  np = length(indx);
end

kn = size(gsa_.xx,1);


nplo = ceil(sqrt(np));
  if nplo*(nplo-2)>=np,
    nplo2=nplo-2;
  elseif nplo*(nplo-1)>=np,
    nplo2=nplo-1;    
  elseif (nplo+1)*(nplo-1)>=np,
    nplo2=nplo-1;    
    nplo=nplo+1;    
  else
    nplo2=nplo;
  end
  
  if nargin<3 | isempty(pnames),
    pnames=['X_{',num2str(1),'}'];
    for j=2:np,
      pnames=str2mat(pnames,['X_{',num2str(j),'}']);
    end
    
  end
  
  figure('name',['Nrun=',num2str(kn),', ',fname,', SDP']),
  f=gsa_.f(:,indx);
  fs=gsa_.fs(:,indx);
  fses=gsa_.fses(:,indx);
  stat=gsa_.stat(indx);
  v_di_e(1,:)=gsa_.si(indx);
  pnames = pnames(indx,:);
  for j=1:np,
    %subplot(3,4,j)
    subplot(nplo2,nplo,j)
    xp=sort(gsa_.x0(:,indx(j)));
    %xp=zs(:,jj)-1;
    if exist('yi_anal') & ~isempty(yi_anal),
      %plot(xp, yi_anal(:,j)./sy,'r:'), hold on, 
      plot(xp, yi_anal(:,indx(j)),'r:'), hold on, 
    end
    plot(xp, fs(:,j),'k', xp, 2.*fses(:,j),':k', xp, -2.*fses(:,j),':k')
    set(gca,'xlim',[min(xp) max(xp)])        
%     lmod(j) = {'I1'};
%     if TVP(j), lmod(j)={'I2'}; end,
    title([deblank(pnames(j,:)),', Si=',num2str(v_di_e(1,j),'%5.2f')],'fontsize',9,'interpreter','tex')
  end
  saveas(gcf,[fname,'_SE'])
  eval(['print -depsc2 ' fname '_SE']);
  eval(['print -dpdf ' fname '_SE']);
%   close(gcf)
  hfig = gcf;
  
%   figure('name',['Nrun=',num2str(kn),', ',fname,', SDP univariate']),    
%   f=gsa_.univariate.f;
%   fs=gsa_.univariate.fs;
%   fses=gsa_.univariate.fses;
%   vi(1,:)=gsa_.univariate.si;
%   vi(2,:)=gsa_.univariate.si_std;
%   for j=1:np,
%     subplot(nplo2,nplo,j)
%     xp=sort(x0(:,j));
%     if exist('yi_anal') & ~isempty(yi_anal),
%       plot(xp, yi_anal(:,j),'r'), hold on, 
%     end
%     plot(xp, [fs(:,j) 3.09.*fses(:,j) -3.09.*fses(:,j)])
%     set(gca,'xlim',[min(xp) max(xp)])        
%     lmod(j) = {'I1'};
%     if TVP(j), lmod(j)={'I2'}; end,
%     title([deblank(pnames(j,:)),', ',lmod{j},', tstat=',num2str(vi(2,j),'%5.2f'), ...
%         ', S=',num2str(vi(1,j),'%5.2f')])
%   end
%   %saveas(gcf,[fname,'_SE_univ'])
%   close(gcf)
