function [yt1, yfit, s2, s22, v2, nvr, chk, gsa1, outk1] = sdr2_cosso2(y2, y0, x, TVP, i2, nvr, chk, gsa1, nest, tcrit, sy, ibkp, fname)
global tstat2crit

if iscell(gsa1),
  ACO=gsa1{2};
  gsa1=gsa1{1};
end

% chk=zeros(size(i2,1),1);
% chk(imult)=1;
load([fname,'_temp'],'v2','s2','s22');
if isempty(who([fname,'_temp'],'yfit0')),
  load( [fname,'_yfit'],'yfit')
  yfit0=yfit;
  yfitse=yfit;
  save([fname,'_temp'],'yfit0','yfitse');
end

% ii2=i2(imult,:);
ii2=i2;
jj2=size(ii2,1);
imult=[1:jj2];
kn=length(y2);
iok=find(~isnan(y2));

np=size(x,2);
nvr1=gsa1.nvr;
% chk1=zeros(np,1);
% chk1(find(gsa1.stat>tstat2crit))=1;
chk1=gsa1.chk;
in1=find(chk1);
nin1=length(in1);
in2=find(chk);
nin2=length(in2);

K03d = zeros(kn,kn,np);
K13d = zeros(kn,kn,np);
Q=zeros(kn,kn);
w0=zeros(1,np);
L20=zeros(1,np);
L21=zeros(1,np);
ichk=0;
for i = 1:np,
%   if gsa1.chk(i),
%     ichk=ichk+1;
%     %     K3darray(:,:,i) = kernel(x(:,i), x(:,i));
%     SS = gsa1.out.S(:,ichk+1)*gsa1.out.d(ichk+1);
%   else
%     b=regress(gsa1.f(:,i),[ones(kn,1) gsa1.xx(:,i)-0.5]);
%     SS = [ones(kn,1) gsa1.xx(:,i)-0.5]*b;
%     b=regress(gsa1.f(:,i),[gsa1.xx(:,i)-0.5]);
    b=[gsa1.xx(:,i)-0.5]\gsa1.f(:,i);
    SS = [gsa1.xx(:,i)-0.5]*b;
%   end
  L20(i) = (mean(SS.^2));
  L21(i) = (mean((gsa1.f(:,i)-SS).^2));
  mL = 0.5*(L20(i)+L21(i));
%   mL = max(L20(i),L21(i));
  L20(i) = sqrt(L20(i)/mL*(mean((gsa1.f(:,i)).^2)));
  L21(i) = sqrt(L21(i)/mL*(mean((gsa1.f(:,i)).^2)));
  w0(i)=L20(i)^2/L21(i)^2;
  [H, H0] = cubic_dm(x(:,i));
  K13d(:,:,i) = H;
  K03d(:,:,i) = H0;
  if gsa1.chk(i),
  Q= Q + (H0*w0(i)+H)*gsa1.nvr(i)*kn^4;
  end
end
clear H H0


S=ones(kn,1);
[yf, out] = splfun(y0,1,S,Q);

%   lamP=1/(kn*1e5);
  lamP=1./[nvr1]./kn^4./w0;
lams.lamk1=[lamP' [1./[nvr1]./kn^4]' ];
lams.lamk2=(1./[nvr]'./kn^4');
if exist('ACO'),
  lams.lamk1=1./[ACO.w(1:np) ACO.w(1:np)].^2.*ACO.lam./kn;  % lambda of ACOSS includes nk !!!!!!!!
  lams.lamk1=1./[L20' L21'].^2.*ACO.lam./kn;
  chk1=chk1*0;
  chk1(find(ACO.theta(1:np)))=1;
  lams.lamk2=1./ACO.w(np+1:end).^2*ones(1,4).*ACO.lam./kn;
  [yt1, outk1] = tcubic_spl_cosso(x, y0, K13d, K03d, lams,2, ACO.theta);
else
  [yt1, outk1] = tcubic_spl_cosso(x, y0, K13d, K03d, lams,2, [chk1; chk]);

end

outk1.lams=lams;
% [yt1, outk1] = tcubic_spl_k(x, y0, 1./[nvr1 nvr]./kn^4,2, [chk1; chk]);
f0=outk1.d(1);
gsa1.L2=sqrt(mean(gsa1.f.^2));
if any(chk),
  [ff, yfit]=tcubic_anova_cosso(x, outk1, K13d, K03d, chk1, lams.lamk1, chk, lams.lamk2); 
  if exist('ACO'),
    ff=ff.*(ones(kn,1)*ACO.theta(1:np)');
    yfit=yfit.*(ones(kn,1)*ACO.theta(np+1:end)');
  end
  yfit0=yfit;
  yfitse=yfit;
  save([fname,'_temp'],'yfit0','yfitse');
  save( [fname,'_yfit'],'yfit')
  f1=sum(ff,2);
  y2=y0-f1-f0;
else
  %   f1=y0-y2-f0;
  ff=gsa1.f;
  yt1=gsa1.fit;
  f1=yt1-f0;
  y2=y0-yt1;
  load( [fname,'_yfit'],'yfit')
end
lamP=L20.^2;
lams.lamk1=[1./L20.^2' 1./L21.^2'];
f2=sum(yfit(:,imult),2);
clear yfit

bic0=outk1.bic;
aic0=kn*log(outk1.SSE/kn)+(outk1.df)*2;
gcv0=outk1.gcv;
df0=outk1.df;

nit=0;
yf = zeros(kn,1);
scrit=1;
r2=1-cov(f0+f1(iok)+f2(iok)-y0(iok))/cov(y0(iok));
if size(nvr,1)==1,
  nvr=[nvr;nvr;nvr;nvr];
end

lam=1./nvr./kn^4;
lam=lam';

% L21=gsa1.L2;

while nit<nest,
  % while (scrit>tcrit & nit<nest) ,
  if nit>0,
    copyfile([fname,'_temp.mat'], ...
      [fname,'_2nd_bkp_',num2str(ibkp+nit),'.mat'])
  end
  nit=nit+1;
  s20=s2;
  r20=r2;
  chk0=chk;
  nvr0=nvr;
  lam0=lam;
  
  h = waitbar(0,['Estimating interactions (backfitting',int2str(nit),')']);
  
  for j=1:jj2,
    ia=logical(chk0(imult));
    %     ia=logical(chk);
    %ia=logical(ones(jj2,1)); %
    ia(j)=false;
    load( [fname,'_yfit'],'yfit')
    if any(ia),
      y22=y2-sum(yfit(:,imult(ia)),2);
    else
      y22=y2;
    end      
    clear yfit
    y22=y22-mean(y22(iok));
    j1=i2(imult(j),1);
    j2=i2(imult(j),2);
    if chk1(j1)==0,
      y22 = y22 - ff(:,j1);
    end
    if chk1(j2)==0,
      y22 = y22 - ff(:,j2);
    end

    [yf, yfse, nvr(3:4,imult(j)), L2(imult(j),:), ichk, stats] = ...
          sdr2it1(y22, x(:,[j1 j2]), TVP, nvr(3:4,imult(j)), kn, 1);
%       [yf, yfse, nvr(2:4,imult(j)), ichk] = ...
%           sdr2it0(y22, x(:,[j1 j2]), 8, nvr(2:4,imult(j)), 1, 1);
%       L2(imult(j)) = sqrt(mean(yf.^2));
    %       lnvrG = fminsearch(@(lnvr) gcv_opt(lnvr,x(:,[j1 j2]),y22),-3);
    %       nvrG=10^lnvrG;
    %       [ytG, outG] = tensor_cubic_spl(x(:,[j1 j2]), y22, 1/nvrG(j)/(kn)^4);
%     L2(imult(j),:) = sqrt(mean(yf.^2));
    chk(imult(j))=1; %ichk;
    tst(imult(j)) = stats.tst;
    waitbar(j/jj2,h)
  end
  close(h)
  L2(find(isnan(L2)))=0;
  
  lams.lamk1=1./[L20' L21'].^2;
  lams.lamk2=1./L2.^2;
%   w=([L21.^2 L2.^2])';
%   K3darray = zeros(kn,kn,np);
  D = length(imult)+np;

% rand('seed',220);
p = randperm(kn);

  theta = ones(D,1);
  theta=[ones(np,1); chk];
%   theta(1:np)=0;
  Kth0 = tcubic_kdm_cosso(K13d, K03d, lams, 2, theta);
%   Kth0 = tcubic_kdm_cosso(K13d, K03d, 1, 2, theta, w);
%   Kth0 = set_K(K3darray, kn, np, 2, theta, sqrt(w));
  theta = ones(D,1);
  opts.K0=0;
  opts.logtrans=0;
  opts.relK=1.e-2;
  opts.nK=30;
  lnvr = gridsearch('gcv_k_opt',[-30 7],opts,y0,ones(kn,1),Kth0,1.01);
  lambda0=1/10^lnvr/kn^4;
  
  chk1=ones(np,1);
  in1=find(chk1);
  nin1=np;
  in2=find(chk);
  nin2=length(in2);
  lams.lamk1=lams.lamk1.*lambda0;
  lams.lamk2=lams.lamk2.*lambda0;
%   lams.lamk2=lambda0./w(np+1:end);
%   lams.lamk2=[lams.lamk2 lams.lamk2 lams.lamk2 lams.lamk2];  
  
  [yt2, outk2] = tcubic_spl_cosso(x, y0, K13d, K03d, lams, 2, [chk1; chk]);
  gcv2 = outk2.gcv;
  bic2 = outk2.bic;
  df2 = outk2.df;
  
  %   ff=gsa1.f*0;
  %
  load( [fname,'_yfit'] ,'yfit')
  yfit0=yfit;
  yfit=yfit*0;
  [G0, yfit]=tcubic_anova_cosso(x, outk2, K13d, K03d, chk1, lams.lamk1, chk, lams.lamk2); 
  chk1(find(var(G0)/var(y0)<1.e-8))=0;
  chk(find(var(yfit)/var(y0)<1.e-8))=0;
  G0=[G0, yfit];
  clear yfit,
  b0=outk2.d(1);
  c0=outk2.c;
  
  opts2.relK=0.05;
  disp('Optimizing M ...')
%   M = gridsearch('cossodeep',[0 D],opts2,y, ord, p, Kth0, K3darray, 5, lambda0, w);
  M = gridsearch('cossopen',[0 D],opts2, x, y0, 2, K13d, K03d, lams, [chk1; chk]);
  disp('... end')
  disp(' ')
  niter = 5;
  while outk2.bic>=bic2 & niter>=2,
    [lams, outk2] = gettheta(x, y0, G0, c0, b0, K13d, K03d, lams, M, [chk1; chk],niter);
    niter = niter-1;
  end
  if (nit>1) & (outk1.Rsq>outk2.Rsq) & (outk1.bic<outk2.bic),
    outk2=outk1;
    r2=outk2.Rsq;
    disp(' ')
    disp(['Backfitting stopped at iteration ',num2str(nit),'    ',num2str(r2)])
    disp('Fit and BIC deteriorate simultaneously!')
    disp(' ')
    break,
  end
  lam=lams.lamk2;
  chk1(find(outk2.theta(1:np)==0))=0;
  chk1(find(outk2.theta(1:np)))=1;
  chk(find(outk2.theta(np+1:end)==0))=0;
  chk(find(outk2.theta(np+1:end)))=1;
  in2=find(chk);
  nin2=length(in2);
  [ff, yfit]=tcubic_anova_cosso(x, outk2, K13d, K03d, chk1, lams.lamk1, chk, lam); 
  theta=outk2.theta;
  for j=1:np, ff(:,j)=ff(:,j).*theta(j); end
  for j=1:jj2, yfit(:,j)=yfit(:,j).*theta(j+np); end
  
  
  f0=outk2.d(1);
  f1=sum(ff,2);
  y2=y0-f1-f0;
  
  f2=sum(yfit(:,logical(chk)),2);
  yt2 = f0+f1+f2;
%   r2=1-cov(f2(iok)+f1(iok)+f0-y0(iok))/cov(y0(iok));
%   save( [fname,'_yfit'] ,'yfit')
%   clear yfit %fit
  outk2.lams=lams;
  if nit<nest
    if any(chk)
      opts=[40 0.001 0 1 1 0 tstat2crit];
      % update main effects
      disp('Update main effects ...')
      if nit<=nest | nit==1,
        [fdum,f1se,par1,parse1,zs1,pars1,parses1,rsq1,nvr1,si1,y01] = sdrnew(y0-f2-f0,ones(size(x)),x,1,-2,opts,[],[],[],0);
      else
        [fdum,f1se,par1,parse1,zs1,pars1,parses1,rsq1,nvr1,si1,y01] = sdrnew(y0-f2-f0,ones(size(x)),x,1,nvr1,opts,[],[],[],0);
      end
      L21=sqrt(mean(par1.^2));
%       y2=y0-f1-f0;
    else
      s2=zeros(jj2,3);
      s22=s22*0;
      v2=zeros(jj2,3);
      load( [fname,'_yfit'] ,'yfit')
      yfit=yfit*0;
      save( [fname,'_yfit'] ,'yfit')
      
%       clear yfit %fit
      outk1=outk2;
      yt1 = yt2;
      return
    end
    
    chk1=chk1*0;
    chk1(find(si1(3,:)>tstat2crit))=1;
    in1=find(chk1);
    nin1=length(in1);
    
    %   if any(chk)
    %     scrit=max(abs(s20(imult(logical(chk)),1)-s2(imult(logical(chk)),1)));
    %   else
    %     scrit=max(abs(s20(imult,1)-s2(imult,1)));
    %   end
    [ytk, outk] = cubic_spl_k(x(:,logical(chk1)), y0-f2-f0, 1./nvr1(logical(chk1))./kn^4);
%     L20=sqrt(mean(par1.^2));
%     L21=sqrt(mean(par1.^2));
%     for j=1:nin1,
%       SS = outk.S(j+1)*outk.d(j+1);
%       L20(in1(j)) = sqrt(mean(SS.^2));
%       L21(in1(j)) = sqrt(mean((par1(:,in1(j))-SS).^2));
%     end
    ichk=0;
    for j=1:np,
      if chk1(j),
        ichk=ichk+1;
        SS = outk.S(ichk+1)*outk.d(ichk+1);
      else
%         b=regress(par1(:,j),[ones(kn,1) gsa1.xx(:,j)-0.5]);
        b=[ones(kn,1) gsa1.xx(:,j)-0.5]\par1(:,j);
        SS = [ones(kn,1) gsa1.xx(:,j)-0.5]*b;
      end
%         par1(:,j) = par1(:,j)-mean(par1(:,j));
%         b=regress(par1(:,j),[gsa1.xx(:,j)-0.5]);
%         SS = [gsa1.xx(:,j)-0.5]*b;
        
      L20(j) = (mean(SS.^2));
      L21(j) = (mean((par1(:,j)-SS).^2));
      mL = 0.5*(L20(j)+L21(j));
%       mL = max(L20(j),L21(j));
      L20(j) = sqrt(L20(j)/mL*(mean((par1(:,j)).^2)));
      L21(j) = sqrt(L21(j)/mL*(mean((par1(:,j)).^2)));
    end
    clear outk ytk
    

%     lams.lamk1(:,2)=1./nvr1./kn^4;
%     theta(1:np)=chk1;
%     
%     [yt1, outk1] = tcubic_spl_cosso(x, y0, lamP, lams, 2, theta);
%     [ff, yfit]=tcubic_anova_cosso(x, outk1, lamP, chk1,1./nvr1./kn^4, chk, lam); 
%     for j=1:np, ff(:,j)=ff(:,j).*theta(j); end
%     for j=1:jj2, yfit(:,j)=yfit(:,j).*theta(j+np); end
  end
  outk1=outk2;
  yt1 = yt2;
%   f0=outk1.d(1);
%   f1=sum(ff,2);
%   f2=sum(yfit,2);
%   y2=y0-f1-f0;
  for j=1:jj2,
    v2(imult(j),1)=var(yfit(:,imult(j)));
    s2(imult(j),1)=v2(imult(j),1)/sy^2;
    u = (y0(iok)-yfit(iok,imult(j)))/sqrt(1-s2(imult(j),1))/sy;
    s2(imult(j),2)=(1-s2(imult(j),1))*std(stand_(y0(iok)).^2-u.^2)/sqrt(length(u));
    s22(i2(imult(j),1),i2(imult(j),2))=s2(imult(j),1);
    s22(i2(imult(j),2),i2(imult(j),1))=s22(i2(imult(j),1),i2(imult(j),2));
    s2(imult(j),3)=s2(imult(j),1)/s2(imult(j),2);
  end
  
  save( [fname,'_yfit'] ,'yfit')
  clear yfit %fit
  
  r2=1-cov(f2(iok)+f1(iok)+f0-y0(iok))/cov(y0(iok));
  %scrit=abs(sum(s20(:,1))-sum(s2(:,1)));
  scrit=abs(r2-r20);
  df0=outk1.df;
  gcv0=outk1.gcv;
  bic0=outk1.bic;
  save([fname,'_temp'],'scrit','-append')
  disp(' ')
  disp(['Backfitting iteration ',num2str(nit),'    ',num2str(r2)])
  disp(' ')
end

if nest==0,
  lams.lamk1=1./nvr1./kn^4;
  lams.lamk2=lam;
  [yt1, outk1] = tcubic_spl_cosso(x, y0, lamP, lams, 2, [chk1; chk]);
  M=sum(chk1)+sum(chk);
  [ff, yfit]=tcubic_anova(x, outk1, lamP, chk1, 1./nvr1./kn^4, chk, lam); 
  f0=outk1.d(1);
  f2=sum(yfit,2);
  opts=[40 0.001 0 1 1 0 tstat2crit];
  [f1,f1se,par1,parse1,zs1,pars1,parses1,rsq1,nvr1,si1,y01] = sdrnew(y0-f2-f0,ones(size(x)),x,1,nvr1,opts,[],[],[],0);
  f1=sum(ff,2);
  for j=1:jj2,
    v2(imult(j),1)=var(yfit(:,imult(j)));
    s2(imult(j),1)=v2(imult(j),1)/sy^2;
    u = (y0(iok)-yfit(iok,imult(j)))/sqrt(1-s2(imult(j),1))/sy;
    s2(imult(j),2)=(1-s2(imult(j),1))*std(stand_(y0(iok)).^2-u.^2)/sqrt(length(u));
    s22(i2(imult(j),1),i2(imult(j),2))=s2(imult(j),1);
    s22(i2(imult(j),2),i2(imult(j),1))=s22(i2(imult(j),1),i2(imult(j),2));
    s2(imult(j),3)=s2(imult(j),1)/s2(imult(j),2);
    
  end
  
  save( [fname,'_yfit'] ,'yfit')
  clear yfit %fit
  
  r2=1-cov(f2(iok)+f1(iok)+f0-y0(iok))/cov(y0(iok));
  df0=outk1.df;
  gcv0=outk1.gcv;
  bic0=outk1.bic;
end

par1=ff;
% par1(:,logical(chk1))=ff(:,logical(chk1));
si=var(par1)./var(y0);
sie=si1(2,:);
tst=si1(3,:);


for j=1:size(x,2),
  %   m0=mean(par1(:,j));
  %   f(:,j)=(par1(:,j)-m0);
  f(:,j)=par1(:,j);
  if chk1(j),
    [xd,I]=sort(x(:,j));
    pars1(:,j)=par1(I,j);
  end
  %   fs(:,j)=(pars1(:,j)-m0);
  fs(:,j)=pars1(:,j);
  fses(:,j)=parses1(:,j);
  
end
ino= find(chk1==0);
iyes= find(chk1);
%   f(:,ino)=f(:,ino)*0;
%   fs(:,ino)=fs(:,ino)*0;
rsq = 1-cov(y0(iok)-f0-sum(f(iok,iyes),2))/cov(y0(iok));

gsa1.fit=f1;
gsa1.f0=f0;
gsa1.f=f;
gsa1.fs=fs;
gsa1.fses=fses;
gsa1.nvr=nvr1;
gsa1.r2=rsq;
gsa1.si=si;
gsa1.si_std=sie;
gsa1.stat=tst;
gsa1.x0=x;
gsa1.xx=x;
gsa1.y=y0;
gsa1.chk=chk1;
gsa1.L2=L21;


load( [fname,'_yfit'])
delete([fname,'_yfit.mat'])
%copyfile([fname,'_temp.mat'],[fname,'_2nd.mat'])
delete([fname,'_temp.mat'])

