function [ff, ff2] = tcubic_anova_cosso(x, outk2, K1, K0, chk1, lam1, chk, lam2),

% computed ANOVA terms from reproducing kernel, EXCLUDING the theta
% coefficients !!!!!!!1

[kn, np]=size(x);

  in1=find(chk1);
  nin1=length(in1);
  ff=zeros(kn,np);

% disp('Constructing main effects ...');
for jj=1:nin1, %np,
  j=in1(jj);
%   [H, H0]=cubic_dm(x(:,j));
  ff(:,j)=(K0(:,:,j)./lam1(j,1)+K1(:,:,j)./lam1(j,2))*outk2.c;
%   ff(:,j)=ff(:,j)-mean(ff(:,j));
end
% disp('... end')
% disp(' ')

if nargout>1,
  if (length(chk)>1 & min(size(lam2))==1) | max(size(lam2))==1,
    lam2=lam2(:);
    lam2=[lam2 lam2 lam2 lam2];
  end
  in2=find(chk);
  nin2=length(in2);
  i2=nchoosek([1:np],2);
  ff2=zeros(kn,size(i2,1));
% disp('Constructing interactions ...');
for jj=1:nin2,
  j=in2(jj);
%   [H, S, H0]=tensor_cubic_dm(x(:,i2(j,:)),[],lam2(j,2:4));
  ind1=i2(j,1);
  ind2=i2(j,2);
  
  ff2(:,j)=ff2(:,j)+(K0(:,:,ind1).*K0(:,:,ind2)./lam2(j,1) + ...
        K1(:,:,ind1).*K1(:,:,ind2)./lam2(j,2) + ...
        K1(:,:,ind1).*K0(:,:,ind2)./lam2(j,3) + ...
        K0(:,:,ind1).*K1(:,:,ind2)./lam2(j,4) )*outk2.c;
%   ff2(:,j)=ff2(:,j)-mean(ff2(:,j));
end
% disp('... end')
% disp(' ')
end
