function ccontour(x,y,z);
% function ccontour(x,y,z, fopt);
% Contour Plots of Nonuniformly Sampled Data


%plot3(x(:,1),x(:,3),yfit(:,1),'.')
if nargin<3, 
  disp(' ')
  disp('ccontour(x,y,z)')
  disp(' ')
  return, 
end,

xlin = linspace(min(x),max(x),15);
ylin = linspace(min(y),max(y),15);
[X,Y] = meshgrid(xlin,ylin);
Z = griddata(x,y,z,X,Y,'cubic');

%mesh(X,Y,Z) %interpolated
[C,h] = contour(X,Y,Z); %interpolated
%set(h,'ShowText','on','TextStep',get(h,'LevelStep')*2)
set(h,'ShowText','on')
axis tight; 

